/**
 * https://developer.wordpress.org/block-editor/developers/block-api/block-registration/#icon-optional
 * https://developer.wordpress.org/block-editor/reference-guides/components/icon/
 */

import { G, Path, SVG, IMAGE, USE } from '@wordpress/components';

export default () => (
	<svg version="1.1" id="Livello_1" xmlns="http://www.w3.org/2000/svg" xmlnsXlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
		 viewBox="0 0 192 192" enableBackground="new 0 0 192 192" xmlSpace="preserve">
<g>
	<defs>
		<path id="SVGID_1_" d="M10,0h172c5.5,0,10,4.5,10,10v172c0,5.5-4.5,10-10,10H10c-5.5,0-10-4.5-10-10V10C0,4.5,4.5,0,10,0z"/>
	</defs>
	<clipPath id="SVGID_2_">
		<use xlinkHref="#SVGID_1_" overflow="visible"/>
	</clipPath>
	<g clipPath="url(#SVGID_2_)">
		<defs>
			<rect id="SVGID_3_" width="192" height="192"/>
		</defs>
		<clipPath id="SVGID_4_">
			<use xlinkHref="#SVGID_3_" overflow="visible"/>
		</clipPath>

		<image overflow="visible" clipPath="url(#SVGID_4_)" width="192" height="192" xlinkHref="data:image/jpeg;base64,/9j/4AAQSkZJRgABAgEASABIAAD/7AARRHVja3kAAQAEAAAAHgAA/+4AIUFkb2JlAGTAAAAAAQMA
EAMCAwYAAAHXAAAB4wAAAgX/2wCEABALCwsMCxAMDBAXDw0PFxsUEBAUGx8XFxcXFx8eFxoaGhoX
Hh4jJSclIx4vLzMzLy9AQEBAQEBAQEBAQEBAQEABEQ8PERMRFRISFRQRFBEUGhQWFhQaJhoaHBoa
JjAjHh4eHiMwKy4nJycuKzU1MDA1NUBAP0BAQEBAQEBAQEBAQP/CABEIAMAAwAMBIgACEQEDEQH/
xABfAAEBAAAAAAAAAAAAAAAAAAAABQEBAQAAAAAAAAAAAAAAAAAAAAUQAQEAAAAAAAAAAAAAAAAA
AHCQEQEAAAAAAAAAAAAAAAAAAACQEgEAAAAAAAAAAAAAAAAAAABw/9oADAMBAAIRAxEAAACOKsoA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD//2gAIAQIA
AQUAEP/aAAgBAwABBQAQ/9oACAEBAAEFAIgf/9oACAECAgY/ABD/2gAIAQMCBj8AEP/aAAgBAQEG
PwAQP//Z">
		</image>
	</g>
</g>
		<g>
	<defs>
		<path id="SVGID_5_" d="M110,102c0,0,13.5-0.1,19,0c5.5,0.1,16.3,6.7,16,17c-0.3,10.5-7.2,13.9-14,16c-7.9,2.4-21,1-21,1V102z
			 M110,58c0,0,9.5-0.2,16,0c5.6,0.2,15.2,4.6,15,13c-0.2,8.4-5.9,14.6-14,15s-17,0-17,0V58z M38,44h-8v108c0,0,85-0.1,97,0
			c14.3,0.1,35.5-10.7,36-29c0.6-22.9-14-30-14-30s10.2-6,10-25c-0.2-21.1-17.7-26.1-32-26c-20.1,0.2-47,2-47,2s18.7,6.4,19,23
			c0.3,16.6-9,24-9,24s13.6,9.6,13,26c-0.6,16.4-13.7,29.2-30,31c-16.3,1.8-34-6-34-6l5-14c0,0,15,7.1,26,4c11-3.1,17.7-11.2,16-19
			c-1.9-8.9-8.6-12.9-14-13c-4.2,0-15,0-15,0V84c0,0,8.2,0,14,0c3.5,0,9.5-4.1,11-9c1.5-4.9-0.2-12.7-6-15c-5.8-2.3-12.6-3.3-22-3
			c-8.5,0.3-13,1-13,1L38,44z"/>
	</defs>
			<clipPath id="SVGID_6_">
		<use xlinkHref="#SVGID_5_" overflow="visible"/>
	</clipPath>
			<g clipPath="url(#SVGID_6_)">
		<defs>
			<rect id="SVGID_7_" width="192" height="192"/>
		</defs>
				<clipPath id="SVGID_8_">
			<use xlinkHref="#SVGID_7_" overflow="visible"/>
		</clipPath>

				<image overflow="visible" clipPath="url(#SVGID_8_)" width="192" height="192" xlinkHref="data:image/jpeg;base64,/9j/4AAQSkZJRgABAgEASABIAAD/7AARRHVja3kAAQAEAAAAHgAA/+4AIUFkb2JlAGTAAAAAAQMA
EAMCAwYAAAHUAAAB4AAAAgL/2wCEABALCwsMCxAMDBAXDw0PFxsUEBAUGx8XFxcXFx8eFxoaGhoX
Hh4jJSclIx4vLzMzLy9AQEBAQEBAQEBAQEBAQEABEQ8PERMRFRISFRQRFBEUGhQWFhQaJhoaHBoa
JjAjHh4eHiMwKy4nJycuKzU1MDA1NUBAP0BAQEBAQEBAQEBAQP/CABEIAMAAwAMBIgACEQEDEQH/
xABeAAEBAAAAAAAAAAAAAAAAAAAABwEBAAAAAAAAAAAAAAAAAAAAABABAQAAAAAAAAAAAAAAAAAA
cJARAQAAAAAAAAAAAAAAAAAAAJASAQAAAAAAAAAAAAAAAAAAAHD/2gAMAwEAAhEDEQAAAKAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD/2gAIAQIAAQUA
EP/aAAgBAwABBQAQ/9oACAEBAAEFAIgf/9oACAECAgY/ABD/2gAIAQMCBj8AEP/aAAgBAQEGPwAQ
P//Z">
		</image>
	</g>
</g>
</svg>

	// <SVG xmlns="http://www.w3.org/2000/svg">
	// 	<image overflow="visible" width="192" height="192" xlinkHref="data:image/jpeg;base64,/9j/4AAQSkZJRgABAgEASABIAAD/7AARRHVja3kAAQAEAAAAHgAA/+4AIUFkb2JlAGTAAAAAAQMA EAMCAwYAAAHXAAAB4wAAAgX/2wCEABALCwsMCxAMDBAXDw0PFxsUEBAUGx8XFxcXFx8eFxoaGhoX Hh4jJSclIx4vLzMzLy9AQEBAQEBAQEBAQEBAQEABEQ8PERMRFRISFRQRFBEUGhQWFhQaJhoaHBoa JjAjHh4eHiMwKy4nJycuKzU1MDA1NUBAP0BAQEBAQEBAQEBAQP/CABEIAMAAwAMBIgACEQEDEQH/ xABfAAEBAAAAAAAAAAAAAAAAAAAABQEBAQAAAAAAAAAAAAAAAAAAAAUQAQEAAAAAAAAAAAAAAAAA AHCQEQEAAAAAAAAAAAAAAAAAAACQEgEAAAAAAAAAAAAAAAAAAABw/9oADAMBAAIRAxEAAACOKsoA AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD//2gAIAQIA AQUAEP/aAAgBAwABBQAQ/9oACAEBAAEFAIgf/9oACAECAgY/ABD/2gAIAQMCBj8AEP/aAAgBAQEG PwAQP//Z">
	// 	</image>
	// </SVG>
);

// <svg viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">
// <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/></svg>
